LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_arith.ALL ;
USE ieee.std_logic_unsigned.ALL ;

-- The ClusterGeneratorFake can be located in either Daughter or Microtronix
--
--Purpose of ClusterGeneratorFake:
--mimic the Leo style cluster generator module for testing downstream modules
--
--It will do this by contiuously presenting the pixel address counter.  On every NTH_PIXEL it will 
--raise the cluster flag
entity ClusterGeneratorFake is
port (
	reset_n : in std_logic ;

-- clock
	clk 	: in std_logic ; -- fast pixel clock, ultimately 100 MHz
	
-- simulated outputs
	PixelAddress : out std_logic_vector(17 downto 0); -- circular memory address'
	PixelAddressto : out std_logic_vector(17 downto 0); -- circular memory address'
													-- i.e. linear address of the pixel frame
	GotCluster : out std_logic -- flag indicating cluster finder has found a cluster
	
--

) ;
end entity ClusterGeneratorFake ;

architecture a of ClusterGeneratorFake is
signal	Address :  std_logic_vector(17 downto 0):="000000000000000000";
signal	Addr :  std_logic_vector(3 downto 0):="0000";


begin


process(clk, reset_n)
begin
  if  reset_n='0' then
	 Addr<=(others=>'0');
	 Address<=(others=>'0');
	 GotCluster<='0';
 else


if clk='1' and clk'event  then
addr<=addr+1;
  Address<=Address+1;
  if 	Addr="0100" or Addr="1001" then
--  if 	Address(0)='1' then
	 GotCluster<='1';
	 else
	 GotCluster<='0';
	end if;
end if;
end if;

end process;
PixelAddressto<=Address;
PixelAddress<="00" & Addr & Addr & Addr & Addr;


end architecture;
