-- trigger_decoder for TCD signals
-- Author: C. Vu
--========= REVISIONs =====================
-- 
--
--========================================== 
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;   

entity trigger_decoder is
    port (
         RHIC			: IN std_logic ;	  		-- ~ 10 MHz in
			RHICx5		: IN std_logic ;	  		-- 5 time RHIC clock in
         rst	      : IN std_logic; 			-- System reset
			Data			: IN std_logic_vector(3 downto 0);
			Token			: OUT std_logic_vector (11 downto 0);	
			comd			: OUT std_logic_vector (3 downto 0);	
			trg_come		: OUT std_logic	
    );
end trigger_decoder;

architecture top_arch of trigger_decoder is
signal RHIC_Latch	: std_logic;
signal trig_out	: std_logic;
signal flag1			: std_logic:='0';
signal flag2			: std_logic:='0';
signal counter		: std_logic_vector (2 downto 0);
signal Trig			: std_logic_vector (3 downto 0);
signal Com			: std_logic_vector (3 downto 0);
--signal Comp			: std_logic_vector (3 downto 0);
signal T1, T2, T3	: std_logic_vector (3 downto 0);
--signal Token		: std_logic_vector (11 downto 0);	
begin

------------------------------------------------------------------
delay_process : process(RHICx5,rst , RHIC)
 begin
	if (rst = '1')  then
		RHIC_Latch 	<= '0'; 	
	elsif (RHICx5  ='0' and RHICx5 'event) then
		RHIC_Latch <= RHIC;
		end if;
		 
end process delay_process  ; 


Counter_process : process(RHICx5,rst , RHIC)
 begin
if (RHICx5  ='0' and RHICx5 'event) then
		if RHIC = '1' and RHIC_Latch = '0' then
		 counter<="000";
		 else
 		 counter<=counter+1;
		end if;
end if;
end process Counter_process  ; 

Latch_process : process(RHICx5,rst , RHIC, counter)
 begin
	if (rst = '1')  then
		T1	 	<= "0000";
		T2	 	<= "0000";
		T3	 	<= "0000";
		Trig	<= "0000";
		Com	<= "0000";
--		Token <= "000000000000"; 
--		trg_come<='0';	
	elsif (RHICx5  ='0' and RHICx5 'event) then	-- Use Falling edge to capture the data in between data switching
		 if trig_out='1' then
 				trig_out<='0';
				end if;

		if counter="000" then
				Trig	<= Data;
 		elsif counter="001" then
				T1	<= Data;
 		elsif counter="010" then
				T2	<= Data;
 		elsif counter="011" then
			 	T3	<= Data;
			if Trig="1000"   then
				Token <= T1&T2&Data;
			end if;
 		elsif counter="100" then
				if Trig="1000"   then
				trig_out<='1';
--				Token <= T1&T2&T3;
			end if;
			 	Com<= Data;
		end if;
	end if;
end process Latch_process  ; 


--Token <= T1&T2&T3 when   Com="1000" and trig_out='1' else
--       "101010101010";
 
--Token <= T3&T2&Com ;
trg_come<=trig_out;
comd<=com;
end top_arch;
