LIBRARY IEEE;
USE IEEE.std_logic_1164.ALL;
USE IEEE.std_logic_unsigned.ALL;
USE IEEE.std_logic_arith.ALL;

ENTITY cds_diff IS
    PORT (
        CLK50           : IN  STD_LOGIC;
        RST             : IN  STD_LOGIC;
         hot_pixel_in  : IN  STD_LOGIC;
        first_pixel_in  : IN  STD_LOGIC;
        first_pixel_out : OUT STD_LOGIC;
        data_adc        : IN  STD_LOGIC_VECTOR (11 DOWNTO 0);
        data_sram       : IN  STD_LOGIC_VECTOR (11 DOWNTO 0);
        data            : OUT STD_LOGIC_VECTOR (11 DOWNTO 0)
        );
END cds_diff;

ARCHITECTURE cds_diff_arch OF cds_diff IS
    SIGNAL first_buf : STD_LOGIC_VECTOR (7 DOWNTO 0):=(others=>'0');

BEGIN  -- cds_diff_arch

    PROCESS (CLK50, RST)
    BEGIN  -- PROCESS
        IF RST = '1' THEN               -- asynchronous reset (active high)
            data <= (OTHERS => '0');
        ELSIF CLK50'EVENT AND CLK50 = '1' THEN  -- rising clock edge
 --           first_pixel_out <= first_pixel_in;
				first_buf(0)<=first_pixel_in;
				first_buf(1)<=first_buf(0);
				first_buf(2)<=first_buf(1);
				first_buf(3)<=first_buf(2);
				first_buf(4)<=first_buf(3);
				first_buf(5)<=first_buf(4);
				first_buf(6)<=first_buf(5);
				first_buf(7)<=first_buf(6);
				first_pixel_out<=first_buf(5);
				--first_pixel_out<=first_pixel_in;

				   
            IF (data_adc < data_sram) and hot_pixel_in = '0' THEN
                data <= data_sram - data_adc;
               --data <= data_sram;
            ELSE
                data <= (OTHERS => '0');
                --data <= data_adc - data_sram  ;
            
				END IF;
        END IF;
    END PROCESS;

END cds_diff_arch;
