--------------------------------------------------------------------------------
-- Copyright (c) 1995-2003 Xilinx, Inc.
-- All Right Reserved.
--------------------------------------------------------------------------------
--   ____  ____ 
--  /   /\/   / 
-- /___/  \  /    Vendor: Xilinx 
-- \   \   \/     Version : 7.1i
--  \   \         Application : 
--  /   /         Filename : dcm50to100.vhd
-- /___/   /\     Timestamp : 08/21/2006 13:35:26
-- \   \  /  \ 
--  \___\/\___\ 
--
--Command: 
--Design Name: dcm50to100
--
-- Module dcm50to100
-- Generated by Xilinx Architecture Wizard
-- Written for synthesis tool: XST

library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
-- synopsys translate_off
library UNISIM;
use UNISIM.Vcomponents.ALL;
-- synopsys translate_on
  
entity dcm50to100 is
   port ( U1_CLKIN_N_IN        : in    std_logic; 
	       U1_CLKIN_P_IN        : in    std_logic; 
	            RHIC_CLK_IN   : in    std_logic; 
            CLK_SELECTION_IN : in    std_logic; 
          U1_RST_IN            : in    std_logic; 
          U1_CLKIN_IBUFGDS_OUT : out   std_logic; 
          U1_CLK2X_OUT         : out   std_logic; 
          U1_STATUS_OUT        : out   std_logic_vector (2 downto 0); 
          U2_CLKDV_OUT         : out   std_logic; 
          U2_CLK0_OUT          : out   std_logic; 
          U2_CLK270_OUT        : out   std_logic; 
          U2_LOCKED_OUT        : out   std_logic; 
          U2_STATUS_OUT        : out   std_logic_vector (2 downto 0));
end dcm50to100;

architecture BEHAVIORAL of dcm50to100 is
   signal GND                  : std_logic;
   signal STATUS_float         : std_logic_vector (4 downto 0);
   signal STATUS_float1        : std_logic_vector (4 downto 0);
   signal U1_CLKFB_IN          : std_logic;
   signal U1_CLKIN_IBUFGDS     : std_logic;
   signal U1_CLK2X_BUF         : std_logic;
   signal U1_LOCKED_INV_IN     : std_logic;
   signal U2_CLKDV_BUF         : std_logic;
   signal U2_CLKFB_IN          : std_logic;
   signal U2_CLKIN_BUF         : std_logic;
   signal U2_CLK0_BUF          : std_logic;
   signal U2_CLK270_BUF        : std_logic;
   signal U2_LOCKED_INV_RST    : std_logic;
   signal U1_CLKIN_IN    : std_logic;
component BUFGMUX
   port  (
      O : OUT std_logic ; -- Clock buffer output
      I0 : IN std_logic ;  -- Clock0 input
      I1 : IN std_logic ;  -- Clock1 input
      S : IN std_logic      -- Clock select input
   );
end component;	
   component DCM
      generic( CLK_FEEDBACK : string :=  "1X";
               CLKDV_DIVIDE : real :=  2.000000;
               CLKFX_DIVIDE : integer :=  1;
               CLKFX_MULTIPLY : integer :=  4;
               CLKIN_DIVIDE_BY_2 : boolean :=  FALSE;
               CLKIN_PERIOD : real :=  0.000000;
               CLKOUT_PHASE_SHIFT : string :=  "NONE";
               DESKEW_ADJUST : string :=  "SYSTEM_SYNCHRONOUS";
               DFS_FREQUENCY_MODE : string :=  "LOW";
               DLL_FREQUENCY_MODE : string :=  "LOW";
               DUTY_CYCLE_CORRECTION : boolean :=  TRUE;
               FACTORY_JF : bit_vector :=  x"C080";
               PHASE_SHIFT : integer :=  0;
               STARTUP_WAIT : boolean :=  FALSE;
               DSS_MODE : string :=  "NONE");
      port ( CLKIN    : in    std_logic; 
             CLKFB    : in    std_logic; 
             RST      : in    std_logic; 
             PSEN     : in    std_logic; 
             PSINCDEC : in    std_logic; 
             PSCLK    : in    std_logic; 
             DSSEN    : in    std_logic; 
             CLK0     : out   std_logic; 
             CLK90    : out   std_logic; 
             CLK180   : out   std_logic; 
             CLK270   : out   std_logic; 
             CLKDV    : out   std_logic; 
             CLK2X    : out   std_logic; 
             CLK2X180 : out   std_logic; 
             CLKFX    : out   std_logic; 
             CLKFX180 : out   std_logic; 
             STATUS   : out   std_logic_vector (7 downto 0); 
             LOCKED   : out   std_logic; 
             PSDONE   : out   std_logic);
   end component;
   
   component INV
      port ( I : in    std_logic; 
             O : out   std_logic);
   end component;
   
   component IBUFGDS
      port ( I  : in    std_logic; 
             IB : in    std_logic; 
             O  : out   std_logic);
   end component;
   
   component BUFG
      port ( I : in    std_logic; 
             O : out   std_logic);
   end component;
   
begin
   GND <= '0';
   U2_CLKIN_BUF <= U1_CLKFB_IN;
--   U1_CLKIN_IBUFGDS_OUT <= U1_CLKIN_IBUFGDS;
	U1_CLKIN_IBUFGDS_OUT<=U1_CLKIN_IN;
   U1_CLK2X_OUT <= U1_CLKFB_IN;
   U1_CLK2X_OUT <= U2_CLKIN_BUF;
   U2_CLK0_OUT <= U2_CLKFB_IN;
   DCM_INST1 : DCM
   generic map( CLK_FEEDBACK => "2X",
            CLKDV_DIVIDE => 2.000000,
            CLKFX_DIVIDE => 1,
            CLKFX_MULTIPLY => 4,
            CLKIN_DIVIDE_BY_2 => FALSE,
            CLKIN_PERIOD => 20.000000,
            CLKOUT_PHASE_SHIFT => "NONE",
            DESKEW_ADJUST => "SYSTEM_SYNCHRONOUS",
            DFS_FREQUENCY_MODE => "LOW",
            DLL_FREQUENCY_MODE => "LOW",
            DUTY_CYCLE_CORRECTION => TRUE,
            FACTORY_JF => x"C080",
            PHASE_SHIFT => 0,
            STARTUP_WAIT => FALSE)
      port map (CLKFB=>U1_CLKFB_IN,
                CLKIN=>U1_CLKIN_IBUFGDS,
                DSSEN=>GND,
                PSCLK=>GND,
                PSEN=>GND,
                PSINCDEC=>GND,
                RST=>U1_RST_IN,
                CLKDV=>open,
                CLKFX=>open,
                CLKFX180=>open,
                CLK0=>open,
                CLK2X=>U1_CLK2X_BUF,
                CLK2X180=>open,
                CLK90=>open,
                CLK180=>open,
                CLK270=>open,
                LOCKED=>U1_LOCKED_INV_IN,
                PSDONE=>open,
                STATUS(7 downto 3)=>STATUS_float(4 downto 0),
                STATUS(2 downto 0)=>U1_STATUS_OUT(2 downto 0));
   
   DCM_INST2 : DCM
   generic map( CLK_FEEDBACK => "1X",
            CLKDV_DIVIDE => 2.000000,
            CLKFX_DIVIDE => 1,
            CLKFX_MULTIPLY => 4,
            CLKIN_DIVIDE_BY_2 => FALSE,
            CLKIN_PERIOD => 10.000000,
            CLKOUT_PHASE_SHIFT => "NONE",
            DESKEW_ADJUST => "SYSTEM_SYNCHRONOUS",
            DFS_FREQUENCY_MODE => "LOW",
            DLL_FREQUENCY_MODE => "LOW",
            DUTY_CYCLE_CORRECTION => TRUE,
            FACTORY_JF => x"C080",
            PHASE_SHIFT => 0,
            STARTUP_WAIT => FALSE)
      port map (CLKFB=>U2_CLKFB_IN,
                CLKIN=>U2_CLKIN_BUF,
                DSSEN=>GND,
                PSCLK=>GND,
                PSEN=>GND,
                PSINCDEC=>GND,
                RST=>U2_LOCKED_INV_RST,
                CLKDV=>U2_CLKDV_BUF,
                CLKFX=>open,
                CLKFX180=>open,
                CLK0=>U2_CLK0_BUF,
                CLK2X=>open,
                CLK2X180=>open,
                CLK90=>open,
                CLK180=>open,
                CLK270=>U2_CLK270_BUF,
                LOCKED=>U2_LOCKED_OUT,
                PSDONE=>open,
                STATUS(7 downto 3)=>STATUS_float1(4 downto 0),
                STATUS(2 downto 0)=>U2_STATUS_OUT(2 downto 0));

	  BUFGMUX_inst : BUFGMUX
  port map (
     O => U1_CLKIN_IBUFGDS,    -- Clock MUX output
     I0 => U1_CLKIN_IN,  -- Clock0 input
     I1 => RHIC_CLK_IN,  -- Clock1 input
     S => CLK_SELECTION_IN     -- Clock select input
  );
   
   INV_INST : INV
      port map (I=>U1_LOCKED_INV_IN,
                O=>U2_LOCKED_INV_RST);
   

   U1_CLKIN_IBUFGDS_INST : IBUFGDS
      port map (I=>U1_CLKIN_P_IN,
                IB=>U1_CLKIN_N_IN,
                O=>U1_CLKIN_IN);
   U1_CLK2X_BUFG_INST : BUFG
      port map (I=>U1_CLK2X_BUF,
                O=>U1_CLKFB_IN);
   
   U2_CLKDV_BUFG_INST : BUFG
      port map (I=>U2_CLKDV_BUF,
                O=>U2_CLKDV_OUT);
   
   U2_CLK0_BUFG_INST : BUFG
      port map (I=>U2_CLK0_BUF,
                O=>U2_CLKFB_IN);
   
   U2_CLK270_BUFG_INST : BUFG
      port map (I=>U2_CLK270_BUF,
                O=>U2_CLK270_OUT);
   
end BEHAVIORAL;


