LIBRARY ieee;
USE ieee.std_logic_1164.ALL;

ENTITY myfifo IS
	port (
		data		: IN STD_LOGIC_VECTOR (31 DOWNTO 0);
		wrreq		: IN STD_LOGIC ;
		rdreq		: IN STD_LOGIC ;
		rdclk		: IN STD_LOGIC ;
		wrclk		: IN STD_LOGIC ;
		aclr		: IN STD_LOGIC  := '0';
		q		: OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
		rdempty		: OUT STD_LOGIC ;
		wrfull		: OUT STD_LOGIC 
		)	 ;
END myfifo;

ARCHITECTURE myfifo_a OF myfifo IS
component fifo 
	port (
	din: IN std_logic_VECTOR(31 downto 0);
	rd_clk: IN std_logic;
	rd_en: IN std_logic;
	rst: IN std_logic;
	wr_clk: IN std_logic;
	wr_en: IN std_logic;
	dout: OUT std_logic_VECTOR(31 downto 0);
	empty: OUT std_logic;
	full: OUT std_logic);
END component;

begin
 fifo_i: fifo 
	port map (
	din=>data,
	rd_clk=>rdclk,
	rd_en=>rdreq,
	rst=>aclr,
	wr_clk=>wrclk,
	wr_en=>wrreq,
	dout=>q,
	empty=>rdempty,
	full=>wrfull
	);
END myfifo_a;

-- synopsys translate_on

