LIBRARY IEEE;
USE IEEE.std_logic_1164.ALL;
USE IEEE.std_logic_unsigned.ALL;
USE IEEE.std_logic_arith.ALL;

ENTITY readout_test IS
    PORT (
        CLK50 : IN  STD_LOGIC;
        RST   : IN  STD_LOGIC;
        -- SRAM PORT
        -- full frame port
        TC    : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
        );
END readout_test;

ARCHITECTURE readout_test_arch OF readout_test IS

BEGIN  -- readout_test_arch

    PROCESS (CLK50, RST)
    BEGIN  -- PROCESS
        IF RST = '1' THEN               -- asynchronous reset (active high)
            state <= IDLE;
        ELSIF CLK50'EVENT AND CLK50 = '1' THEN  -- rising clock edge
            CASE state IS
                WHEN IDLE =>
                    state <= START_ACQ;
                WHEN START_ACQ =>
                    IF wait_cnt = 1000 THEN
                        state <= WAIT_ACQ_DONE;
                    END IF;
                WHEN WAIT_ACQ_DONE =>
                    NULL;
                WHEN START_FULL_FRAME_RD =>
                    NULL;
                WHEN OTHERS =>
                    NULL;
            END CASE;
        END IF;
    END PROCESS;

END readout_test_arch;
