--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:    15:59:32 05/17/06
-- Design Name:    
-- Module Name:    switch - Behavioral
-- Project Name:   
-- Target Device:  
-- Tool versions:  
-- Description:
--
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 	 
--------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity switch is
    Port ( clk : in std_logic;
           reset : in std_logic;
			--   ava_clk : in std_logic;
        RST             : OUT    STD_LOGIC;
        RST_DCM         : OUT    STD_LOGIC;
        dcm_adc_locked  : IN   STD_LOGIC;
        -- setup
        idle            : IN   STD_LOGIC;
        fake_data_mode  : OUT    STD_LOGIC;
        do_resync       : OUT    STD_LOGIC;  -- when doOUTg jtag
        resync_status   : IN   STD_LOGIC;
        do_daq          : OUT    STD_LOGIC;
        daq_busy        : IN   STD_LOGIC;
        do_cds_daq      : OUT    STD_LOGIC;
        cds_daq_busy    : IN   STD_LOGIC;
        get_nios_io     : OUT    STD_LOGIC;
        got_nios_io     : IN   STD_LOGIC;
        do_clr_mem      : OUT    STD_LOGIC;
        clr_mem_busy    : IN   STD_LOGIC;
        do_full_frame   : OUT    STD_LOGIC;
        full_frame_busy : IN STD_LOGIC;
        daq_error       : IN   STD_LOGIC;
        ack_daq_error   : OUT    STD_LOGIC;
        do_mem_test     : OUT    STD_LOGIC;
        mem_test_busy   : IN   STD_LOGIC;
        mem_test_done   : IN   STD_LOGIC;
        -- random read write
        nios_addr       : OUT    STD_LOGIC_VECTOR (17 DOWNTO 0);
        nios_wr         : OUT    STD_LOGIC;
        nios_data_wr    : OUT    STD_LOGIC_VECTOR (143 DOWNTO 0);
        nios_data_rd    : IN   STD_LOGIC_VECTOR (143 DOWNTO 0);
        -- full frame read
        adc_select      : OUT    STD_LOGIC_VECTOR (2 DOWNTO 0);
        sort_select      : OUT    STD_LOGIC_VECTOR (3 DOWNTO 0);
        full_frame_addr : IN   STD_LOGIC_VECTOR (17 DOWNTO 0);
        full_frame_data : IN   STD_LOGIC_VECTOR (11 DOWNTO 0);
        full_frame_wr   : IN   STD_LOGIC;
        full_frame_done : IN   STD_LOGIC;
	     frame_data    : in   STD_LOGIC_VECTOR (143 DOWNTO 0);
		  frame_address    : in   STD_LOGIC_VECTOR (17 DOWNTO 0);
        -- mem test
        mem_test_fail   : IN   STD_LOGIC;
        -- mimostar2
        CkRdC           : IN   STD_LOGIC;
        SYNC            : IN   STD_LOGIC;
        MxFirst         : OUT    STD_LOGIC;
        pixel_addr : IN STD_LOGIC_VECTOR (17 DOWNTO 0);
        cluster_we : IN STD_LOGIC_VECTOR ( 7 DOWNTO 0);


        ostatus : IN STD_LOGIC_VECTOR (31 DOWNTO 0);

           addr : in std_logic_vector(6 downto 0);
--           datain : in std_logic_vector(31 downto 0);

		fifo_data1			: INout	STD_LOGIC ;-- the data I.E. the address of cluster center
		fifo_data2			: INout	STD_LOGIC_VECTOR(19 downto 0) ;-- the data I.E. the address of cluster center
		fifo_data3			: INout	STD_LOGIC ;-- the data I.E. the address of cluster center
		fifo_data4			: INout	STD_LOGIC ;-- the data I.E. the address of cluster center
		fifo_data5			: INout	STD_LOGIC_VECTOR(8 downto 0) ;-- the data I.E. the address of cluster center

           req : in std_logic;
           ready : out std_logic;
           threshold_o : out std_logic_vector (8 downto 0);

			Token			: in std_logic_vector (11 downto 0);	
			trg_come		: in std_logic	;
--			read_ready		: in STD_LOGIC_VECTOR(4 downto 0); 
--         fifo_addr_out		: out STD_LOGIC_VECTOR(6 downto 0);
			ready_flag		: in STD_LOGIC; 
 			trigger_flag		: in STD_LOGIC 
             
			  );
end switch;

architecture Behavioral of switch is


signal address_counter :  STD_LOGIC_VECTOR (17 DOWNTO 0):=(others=>'0');
signal address_delay :  STD_LOGIC_VECTOR (6 DOWNTO 0):=(others=>'0');
signal command :  STD_LOGIC_VECTOR (15 DOWNTO 0):=(others=>'0');
signal  dataout :  std_logic_vector(31 downto 0);
signal  datain :  std_logic_vector(31 downto 0);
signal  R_adc_select :  std_logic_vector(3 downto 0);
signal  R_sort_select :  std_logic_vector(3 downto 0);
signal  fullframe_ready :  std_logic:='0';
signal  fullframe_counter :  std_logic_vector(17 downto 0):=(others=>'0');
signal  bfullframe_counter :  std_logic_vector(31 downto 0):=(others=>'0');
signal  read_ready_counter :  std_logic_vector(3 downto 0):=(others=>'0');
 
signal  Inios_addr       :     STD_LOGIC_VECTOR (17 DOWNTO 0);
signal  buffer_fifo_addr_in        :     integer:=0;
signal  Inios_data_wr    :     STD_LOGIC_VECTOR (143 DOWNTO 0);
signal  reqb    :     STD_LOGIC;



begin
fifo_data1<=dataout(31)   				when CONV_INTEGER(addr)>39 and CONV_INTEGER(addr)<51 else 'Z' ;  
fifo_data2<=dataout(30 downto 11)   when CONV_INTEGER(addr)>39 and CONV_INTEGER(addr)<51 else (others=>'Z'); 
fifo_data3<=dataout(10)  	     		when CONV_INTEGER(addr)>39 and CONV_INTEGER(addr)<51 else 'Z'	;
fifo_data4<=dataout(9)  		 		when CONV_INTEGER(addr)>39 and CONV_INTEGER(addr)<51 else 'Z'  ;
fifo_data5<=dataout(8 downto 0)     when CONV_INTEGER(addr)>39 and CONV_INTEGER(addr)<51 else (others=>'Z'); 



        RST_DCM         <=command(1);


process(clk)
 begin
 if  clk='1' and clk'event then







-- buffer_fifo_addr_in<=CONV_INTEGER(addr);
			-- if buffer_fifo_addr_in>=0 and  buffer_fifo_addr_in<20 then
				-- fifo_addr_out<=CONV_STD_LOGIC_VECTOR(buffer_fifo_addr_in+CONV_INTEGER(read_ready_counter)*3,7);
			-- else
			   -- fifo_addr_out<=(others=>'1');
         -- end if;

	     -- if read_ready(4)='1' and read_ready(3)='0' then
		  -- read_ready_counter<=CONV_STD_LOGIC_VECTOR(4,4);
     -- elsif read_ready(3)='1' and read_ready(2)='0' then
		  -- read_ready_counter<=CONV_STD_LOGIC_VECTOR(3,4);
     -- elsif read_ready(2)='1' and read_ready(1)='0' then
		  -- read_ready_counter<=CONV_STD_LOGIC_VECTOR(2,4);
     -- elsif read_ready(1)='1' and read_ready(0)='0' then
		  -- read_ready_counter<=CONV_STD_LOGIC_VECTOR(1,4);
     -- elsif read_ready(0)='1'  then
		  -- read_ready_counter<=CONV_STD_LOGIC_VECTOR(0,4);
     -- else
		  -- read_ready_counter<=CONV_STD_LOGIC_VECTOR(5,4);
	  -- end if;



			nios_addr<=Inios_addr;
			nios_data_wr<=Inios_data_wr;
         RST             <=command(0);
        fake_data_mode  <=command(2);
        do_resync       <=command(3);  
        do_daq          <=command(4);
        do_cds_daq      <=command(5);
        get_nios_io     <=command(6);
        do_clr_mem      <=command(7);
        do_full_frame   <=command(8);
        ack_daq_error   <=command(9);
        do_mem_test     <=command(10);
        nios_wr         <=command(11);
        MxFirst         <=command(12);


  adc_select<=R_adc_select(2 downto 0);
 sort_select<=R_sort_select;


 	  dataout(31 downto 0)<= (others=>'Z');

	  if CONV_INTEGER(addr)=40 then
	  dataout(31 downto 0)<= "0000000000000000"	&
         dcm_adc_locked  &	  --15
         idle            &	  --14
         resync_status   &	  --13
         daq_busy        &	  --12
         cds_daq_busy    &	  --11
         got_nios_io     &	  --10
         clr_mem_busy    &	  --9
         full_frame_busy &	  --8
         daq_error       &	  --7
         mem_test_busy   &	  --6
         mem_test_done   &	  --5
         full_frame_wr   &	  --4
         full_frame_done &	  --3
         mem_test_fail   &	  --2
         CkRdC           &	  --1
         SYNC		;
	  end if;

	  if CONV_INTEGER(addr)=41 then
	  dataout(31 downto 0)<= nios_data_rd(31 downto 0);
	  end if;
	  if CONV_INTEGER(addr)=42 then
	  dataout(31 downto 0)<= nios_data_rd(63 downto 32);
	  end if;
	  if CONV_INTEGER(addr)=43 then
	  dataout(31 downto 0)<= nios_data_rd(95 downto 64);
	  end if;
	  if CONV_INTEGER(addr)=44 then
	  dataout(31 downto 0)<= nios_data_rd(127 downto 96);
	  end if;
	  if CONV_INTEGER(addr)=45 then
	  dataout(31 downto 0)<= "0000000000000000" & nios_data_rd(143 downto 128);
	  end if;
	  if CONV_INTEGER(addr)=46 then
	  dataout(31 downto 0)<= "00000000000000" & full_frame_addr(17 downto 0);
	  end if;
	  if CONV_INTEGER(addr)=47 then
	  dataout(31 downto 0)<= x"0000000" & read_ready_counter;
	  end if;
	  if CONV_INTEGER(addr)=48 then
	  dataout(31 downto 0)<= x"00000" & Token;
	  end if;
	  if CONV_INTEGER(addr)=49 then
	  dataout(31 downto 0)<=  bfullframe_counter;
	  end if;
	  if CONV_INTEGER(addr)=50 then
	  dataout(31 downto 0)<= ostatus;
	  end if;


 end if;
 end process;
-- dataout(31 downto 0)<= "0000000000000000"	&
--        dcm_adc_locked  &	  --15
--        idle            &	  --14
--        resync_status   &	  --13
--        daq_busy        &	  --12
--        cds_daq_busy    &	  --11
--        got_nios_io     &	  --10
--        clr_mem_busy    &	  --9
--        full_frame_busy &	  --8
--        daq_error       &	  --7
--        mem_test_busy   &	  --6
--        mem_test_done   &	  --5
--        full_frame_wr   &	  --4
--        full_frame_done &	  --3
--        mem_test_fail   &	  --2
--        CkRdC           &	  --1
--        SYNC                  					when CONV_INTEGER(addr)=40 else 
--		   nios_data_rd(31 downto 0)	 			when CONV_INTEGER(addr)=41 else
--		   nios_data_rd(63 downto 32) 			when CONV_INTEGER(addr)=42 else
--		   nios_data_rd(95 downto 64) 			when CONV_INTEGER(addr)=43 else
--		   nios_data_rd(127 downto 96) 			when CONV_INTEGER(addr)=44 else
--		   "0000000000000000" & nios_data_rd(143 downto 128) 			when CONV_INTEGER(addr)=45 else
--
--		  "00000000000000" & full_frame_addr(17 downto 0) 			when CONV_INTEGER(addr)=46 else
--		  "00000000000000000000" & full_frame_data(11 downto 0)	when CONV_INTEGER(addr)=47 else
--		  x"00000" & Token				when CONV_INTEGER(addr)=48 else
--		 bfullframe_counter 	when CONV_INTEGER(addr)=49 else
--		  ostatus											 					when CONV_INTEGER(addr)=50 else
--      (others=>'Z');


 process(req)
begin
if  req='0' and req'event then
   

if CONV_INTEGER(addr)=51 then
	command(CONV_INTEGER(fifo_data5(3 downto 0)))<='1';
end if;

if CONV_INTEGER(addr)=52 then
		command(CONV_INTEGER(fifo_data5(3 downto 0)))<='0';
end if;

if CONV_INTEGER(addr)=53 then
		command<=(others=>'0');
end if;

if CONV_INTEGER(addr)=54 then
		Inios_addr<=fifo_data2(6 downto 0) & fifo_data3 & fifo_data4 & fifo_data5;
end if;

if CONV_INTEGER(addr)=55 then
		Inios_data_wr(31 downto 0)<=fifo_data1 & fifo_data2 & fifo_data3 & fifo_data4 & fifo_data5;
end if;

if CONV_INTEGER(addr)=56 then
		Inios_data_wr(63 downto 32)<=fifo_data1 & fifo_data2 & fifo_data3 & fifo_data4 & fifo_data5;
end if;

if CONV_INTEGER(addr)=57 then
		Inios_data_wr(95 downto 64)<=fifo_data1 & fifo_data2 & fifo_data3 & fifo_data4 & fifo_data5;
end if;

if CONV_INTEGER(addr)=58 then
		Inios_data_wr(127 downto 96)<=fifo_data1 & fifo_data2 & fifo_data3 & fifo_data4 & fifo_data5;
end if;

if CONV_INTEGER(addr)=59 then
		Inios_data_wr(143 downto 128)<=fifo_data2(4 downto 0) & fifo_data3 & fifo_data4 & fifo_data5;
end if;

if CONV_INTEGER(addr)=60 then
		R_adc_select<=fifo_data5(3 downto 0);
end if;

if CONV_INTEGER(addr)=61 then
		R_sort_select<=fifo_data5(3 downto 0);
end if;

if CONV_INTEGER(addr)=62 then
		threshold_o<=fifo_data5;
end if;




end if;
end process;

process(clk)
begin
if  clk='0' and clk'event then


		if	R_adc_select="0000" then
		 bfullframe_counter<=frame_address(17 downto 0)  & "0" & trigger_flag &frame_data(11 downto 0);
		-- bfullframe_counter<=frame_data(31 downto 0);
		end if;
		if	R_adc_select="0001" then
		 bfullframe_counter<=frame_address(17 downto 0)  & "0" & trigger_flag &frame_data(27 downto 16);
		end if;
		if	R_adc_select="0010" then
		 bfullframe_counter<=frame_address(17 downto 0)  & "0" & trigger_flag &frame_data(43 downto 32);
		end if;
		if	R_adc_select="0011" then
		 bfullframe_counter<=frame_address(17 downto 0)  & "0" & trigger_flag &frame_data(59 downto 48);
		end if;
		if	R_adc_select="0100" then
		 --bfullframe_counter<=frame_address(17 downto 0)  & "00" &frame_data(75 downto 64);
		 		 bfullframe_counter<=frame_data(95 downto 64);

		end if;
		if	R_adc_select="0101" then
		 bfullframe_counter<=frame_address(17 downto 0)  & "0" & trigger_flag &frame_data(91 downto 80);

		end if;
		if	R_adc_select="0110" then
		 bfullframe_counter<=frame_address(17 downto 0)  & "0" & trigger_flag &frame_data(107 downto 96);
		end if;
		if	R_adc_select="0111" then
		 bfullframe_counter<=frame_address(17 downto 0)  & "0" & trigger_flag &frame_data(123 downto 112);
		end if;
		
		
		if	R_adc_select="1000" then
		 bfullframe_counter<=frame_address(17 downto 0)  & "000000" & frame_data(135 downto 128);
		end if;
		   	
--	  if bfullframe_counter(0)='0' then
--		bfullframe_counter<=x"55555555";
--		else
--		bfullframe_counter<=x"aaaaaaaa";
--		end if;

end if;



end process;

ready<=ready_flag when CONV_INTEGER(addr)=49  and R_sort_select="0100" else
'1'		when 	  CONV_INTEGER(addr)=49 else
trg_come when CONV_INTEGER(addr)=48 else
'0'				 when  CONV_INTEGER(addr)>14 else
	 'Z';



end Behavioral;
