--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:    19:56:55 04/24/06
-- Design Name:    
-- Module Name:    writedeligater - Behavioral
-- Project Name:   
-- Target Device:  
-- Tool versions:  
-- Description:
--
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
--------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity writedeligater is
    Port ( 
		 	reset_n : in std_logic ;
			 clk : in std_logic;
           trg_come : in std_logic;
           trigger_counter : out std_logic_vector(11 downto 0);
           fifo_select : out std_logic_vector(4 downto 0);
           idle_state : in std_logic_vector(4 downto 0)--;
--           busy_state : in std_logic_vector(4 downto 0)
--			  trigger_ons : out std_logic_vector(4 downto 0);
--           trigger_offs : out std_logic_vector(4 downto 0)
			  )  ;

end writedeligater;

architecture Behavioral of writedeligater is
signal trigger_on 			: std_logic_vector(4 downto 0):=(others=>'0');
signal trigger_on_buf 			: std_logic_vector(4 downto 0):=(others=>'0');
signal trigger_off 			: std_logic_vector(4 downto 0):=(others=>'0');
signal fifocounter 			: std_logic_vector(4 downto 0):="00100";
signal delaycounter 			: std_logic_vector(4 downto 0):="00000";
signal triggercounter 			: std_logic_vector(11 downto 0):=(others=>'0');
signal channelfull 			: std_logic:='0';
signal trg_delay1 			: std_logic:='0';
signal trg_delay2			: std_logic:='0';


begin

 -------------------------------------------------------------------------------------------
-- process(trg_come, reset_n)
-- begin
--   if  reset_n='0' then
-- trigger_on<=(others=>'0');
--  else
-- if  trg_come='1'and trg_come'event then
-- trigger_on<=trigger_on+1;	
-- triggercounter<=triggercounter+1;
-- end if;
-- end if;
-- end process;

trigger_counter<=channelfull & "000" & fifocounter(3 downto 0) & triggercounter(3 downto 0);

sm0:process(clk, reset_n)
begin
  if  reset_n='0' then
trigger_off<=(others=>'0');
fifocounter<="00011";
fifo_select<="00000";
triggercounter<=(others=>'0');
 else
if  clk='1'and clk'event then		 --a fifo_select comes, set a bit of idle
trg_delay1<=trg_come;
trg_delay2<=trg_delay1;
--trigger_on_buf<=trigger_on;

--  if trigger_off/=trigger_on_buf then
--  delaycounter<="00000";
--	  trigger_off<=trigger_on_buf;
  if trg_delay2='1' and trg_delay1='0'  then
  triggercounter<=triggercounter+1;
    channelfull<='1';
--	trigger_on<="00000";
	delaycounter<="00000";
if delaycounter="01111" then
	if CONV_INTEGER(fifocounter)=0 and idle_state(1)='1' then
		  fifo_select(1)<='1';
		   fifocounter<=CONV_std_logic_vector(1,5);
			channelfull<='0';
	end if;
	if CONV_INTEGER(fifocounter)=1 and idle_state(2)='1' then
		  fifo_select(2)<='1';
		   fifocounter<=CONV_std_logic_vector(2,5);
			channelfull<='0';
	end if;
	if CONV_INTEGER(fifocounter)=2 and idle_state(3)='1' then
		  fifo_select(3)<='1';
		   fifocounter<=CONV_std_logic_vector(3,5);
			channelfull<='0';
	end if;
	if CONV_INTEGER(fifocounter)=3 and idle_state(0)='1' then
		  fifo_select(0)<='1';
		   fifocounter<=CONV_std_logic_vector(0,5);
			channelfull<='0';
	end if;
--	if CONV_INTEGER(fifocounter)=4 and idle_state(0)='1' then
--		  fifo_select(0)<='1';
--		   fifocounter<=CONV_std_logic_vector(0,5);
--			channelfull<='0';
--	end if;
end if;
	 
 	 -- if CONV_INTEGER(fifocounter)<4 and	idle_state(CONV_INTEGER(fifocounter)+1)='1' then
	  -- fifo_select(CONV_INTEGER(fifocounter)+1)<='1';
	   -- fifocounter<=fifocounter+1;

		-- channelfull<='0';

	 -- end  if;
   
	
	 -- if CONV_INTEGER(fifocounter)=4 and	idle_state(0)='1' then
	  -- fifo_select(0)<='1';
	   -- fifocounter<=(others=>'0');

		-- channelfull<='0';

	 -- end  if;
   

	else
	if delaycounter/="01111" then
	  delaycounter<=delaycounter+1;
	end if;
	if delaycounter="01111" then
		if idle_state(0)='0' then
	  fifo_select(0)<='0';
	  end if;

	   if	idle_state(1)='0' then
	  fifo_select(1)<='0';
	  end if;

		if	idle_state(2)='0' then
	  fifo_select(2)<='0';
 	  end if;

		if	idle_state(3)='0' then
	  fifo_select(3)<='0';
	  end if;

--		if	idle_state(4)='0' then
--	  fifo_select(4)<='0';
--	  end if;
	end if;
	end if;

	 
 end if;
    end if;
end process;
----------------------------------------------------------------------------------------------
--trigger_ons<=trigger_on;
--trigger_offs<=trigger_off;

end Behavioral;
